#include <stdio.h>
#include <stdbool.h>

int main() {
    int h,n;
    scanf("%d%d\n", &h, &n);
    bool kamenje[h][n];
    
    // unos
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < n; j++) {
            char mozda;
            scanf("%c ", &mozda);
            kamenje[i][j] = (mozda == '1') ? false : true;
        }
    }
    
    // deklarisanje
    int kamen=0;
    int levi=0;
    int desni=0;
    int voda[h][n];
    
    // inicijalizacija
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < n; j++) {
            voda[i][j] = 0;
        }
    }
    
    // prvi red
    for (int i = 0; i < n; i++) {
        if(kamenje[0][i]) {
            if(kamen==0)
                levi=i;
            desni=i;
            kamen++;
            if(i == n-1){
                voda[0][levi - 1] += kamen;
                kamen = 0;
                levi = 0;
                desni = 0;
                break;
            }
            
            if(!kamenje[0][desni+1]) {
                if(levi==0) {
                    voda[0][desni + 1] += kamen;
                }
                else {
                    voda[0][levi - 1] += kamen/2 + kamen%2;
                    voda[0][desni + 1] += kamen/2;
                }
            }
        }
        else {
            kamen = 0;
            levi = 0;
            desni = 0;
            voda[0][i] += 1;
        }
        
    }
    
    // ostali redovi
    
    for (int i = 1; i < h; i++) {
        for (int j = 0; j < n; j++) {
            if(kamenje[i][j]) {
                if(kamen==0)
                    levi=j;
                desni=j;
                kamen+=voda[i-1][j];
                if(j == n-1){
                    voda[i][levi - 1] += kamen;
                    kamen = 0;
                    levi = 0;
                    desni = 0;
                    break;
                }
            
                if(!kamenje[i][desni+1]) {
                    if(levi==0) {
                        voda[i][desni + 1] += kamen;
                    }
                    else {
                        voda[i][levi - 1] += kamen/2;
                        voda[i][desni + 1] += kamen/2;
                        if(i%2==0) {
                            voda[i][levi - 1] += kamen%2;
                        }
                        else {
                            voda[i][desni + 1] += kamen%2;
                            
                        }
                    }
                }
            }
            else {
                kamen = 0;
                levi = 0;
                desni = 0;
                voda[i][j] += voda[i-1][j];
            }
        }
    }
    

        for (int j = 0; j < n-1; j++) {
            printf("%d ", voda[h-1][j]);
        }
        printf("%d", voda[h-1][n-1]);
    return 0;
}